Index: uspace/drv/ohci/batch.c
===================================================================
--- uspace/drv/ohci/batch.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/ohci/batch.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -44,12 +44,26 @@
 #include "hw_struct/transfer_descriptor.h"
 
+/** OHCI specific data required for USB transfer */
 typedef struct ohci_transfer_batch {
+	/** Endpoint descriptor of the target endpoint. */
 	ed_t *ed;
+	/** List of TDs needed for the transfer */
 	td_t **tds;
+	/** Number of TDs used by the transfer */
 	size_t td_count;
+	/** Dummy TD to be left at the ED and used by the next transfer */
 	size_t leave_td;
-	char *device_buffer;
+	/** Data buffer, must be accessible byb the OHCI hw. */
+	void *device_buffer;
 } ohci_transfer_batch_t;
-
+/*----------------------------------------------------------------------------*/
+static void batch_control(usb_transfer_batch_t *instance,
+    usb_direction_t data_dir, usb_direction_t status_dir);
+static void batch_data(usb_transfer_batch_t *instance);
+/*----------------------------------------------------------------------------*/
+/** Safely destructs ohci_transfer_batch_t structure
+ *
+ * @param[in] ohci_batch Instance to destroy.
+ */
 static void ohci_transfer_batch_dispose(void *ohci_batch)
 {
@@ -69,10 +83,23 @@
 }
 /*----------------------------------------------------------------------------*/
-static void batch_control(usb_transfer_batch_t *instance,
-    usb_direction_t data_dir, usb_direction_t status_dir);
-static void batch_data(usb_transfer_batch_t *instance);
-/*----------------------------------------------------------------------------*/
+/** Allocate memory initialize internal structures
+ *
+ * @param[in] fun DDF function to pass to callback.
+ * @param[in] ep Communication target
+ * @param[in] buffer Data source/destination.
+ * @param[in] buffer_size Size of the buffer.
+ * @param[in] setup_buffer Setup data source (if not NULL)
+ * @param[in] setup_size Size of setup_buffer (should be always 8)
+ * @param[in] func_in function to call on inbound transfer completion
+ * @param[in] func_out function to call on outbound transfer completion
+ * @param[in] arg additional parameter to func_in or func_out
+ * @return Valid pointer if all structures were successfully created,
+ * NULL otherwise.
+ *
+ * Allocates and initializes structures needed by the OHCI hw for the transfer.
+ */
 usb_transfer_batch_t * batch_get(ddf_fun_t *fun, endpoint_t *ep,
-    char *buffer, size_t buffer_size, char* setup_buffer, size_t setup_size,
+    char *buffer, size_t buffer_size,
+    const char *setup_buffer, size_t setup_size,
     usbhc_iface_transfer_in_callback_t func_in,
     usbhc_iface_transfer_out_callback_t func_out, void *arg)
@@ -94,5 +121,5 @@
 	    ohci_transfer_batch_dispose);
 
-	hcd_endpoint_t *hcd_ep = hcd_endpoint_get(ep);
+	const hcd_endpoint_t *hcd_ep = hcd_endpoint_get(ep);
 	assert(hcd_ep);
 
@@ -103,13 +130,15 @@
 	data->td_count =
 	    ((buffer_size + OHCI_TD_MAX_TRANSFER - 1) / OHCI_TD_MAX_TRANSFER);
+	/* Control transfer need Setup and Status stage */
 	if (ep->transfer_type == USB_TRANSFER_CONTROL) {
 		data->td_count += 2;
 	}
 
-	/* we need one extra place for td that is currently assigned to hcd_ep*/
+	/* We need an extra place for TD that is currently assigned to hcd_ep*/
 	data->tds = calloc(sizeof(td_t*), data->td_count + 1);
 	CHECK_NULL_DISPOSE_RETURN(data->tds,
 	    "Failed to allocate transfer descriptors.\n");
 
+	/* Add TD left over by the previous transfer */
 	data->tds[0] = hcd_ep->td;
 	data->leave_td = 0;
@@ -123,4 +152,8 @@
 	data->ed = hcd_ep->ed;
 
+	/* NOTE: OHCI is capable of handling buffer that crosses page boundaries
+	 * it is, however, not capable of handling buffer that occupies more
+	 * than two pages (the first page is computed using start pointer, the
+	 * other using the end pointer) */
         if (setup_size + buffer_size > 0) {
 		data->device_buffer = malloc32(setup_size + buffer_size);
@@ -135,4 +168,13 @@
 }
 /*----------------------------------------------------------------------------*/
+/** Check batch TDs' status.
+ *
+ * @param[in] instance Batch structure to use.
+ * @return False, if there is an active TD, true otherwise.
+ *
+ * Walk all TDs (usually there is just one). Stop with false if there is an
+ * active TD. Stop with true if an error is found. Return true if the walk
+ * completes with the last TD.
+ */
 bool batch_is_complete(usb_transfer_batch_t *instance)
 {
@@ -140,7 +182,6 @@
 	ohci_transfer_batch_t *data = instance->private_data;
 	assert(data);
-	size_t tds = data->td_count;
 	usb_log_debug("Batch(%p) checking %zu td(s) for completion.\n",
-	    instance, tds);
+	    instance, data->td_count);
 	usb_log_debug("ED: %x:%x:%x:%x.\n",
 	    data->ed->status, data->ed->td_head, data->ed->td_tail,
@@ -148,5 +189,5 @@
 	size_t i = 0;
 	instance->transfered_size = instance->buffer_size;
-	for (; i < tds; ++i) {
+	for (; i < data->td_count; ++i) {
 		assert(data->tds[i] != NULL);
 		usb_log_debug("TD %zu: %x:%x:%x:%x.\n", i,
@@ -173,10 +214,11 @@
 	assert(hcd_ep);
 	hcd_ep->td = data->tds[i];
-	if (i > 0)
-		instance->transfered_size -= td_remain_size(data->tds[i - 1]);
+	assert(i > 0);
+	for (--i;i < data->td_count; ++i)
+		instance->transfered_size -= td_remain_size(data->tds[i]);
 
 	/* Clear possible ED HALT */
 	data->ed->td_head &= ~ED_TDHEAD_HALTED_FLAG;
-	uint32_t pa = addr_to_phys(hcd_ep->td);
+	const uint32_t pa = addr_to_phys(hcd_ep->td);
 	assert(pa == (data->ed->td_head & ED_TDHEAD_PTR_MASK));
 	assert(pa == (data->ed->td_tail & ED_TDTAIL_PTR_MASK));
@@ -185,4 +227,8 @@
 }
 /*----------------------------------------------------------------------------*/
+/** Starts execution of the TD list
+ *
+ * @param[in] instance Batch structure to use
+ */
 void batch_commit(usb_transfer_batch_t *instance)
 {
@@ -193,4 +239,11 @@
 }
 /*----------------------------------------------------------------------------*/
+/** Prepares control write transfer.
+ *
+ * @param[in] instance Batch structure to use.
+ *
+ * Uses generic control transfer using direction OUT(data stage) and
+ * IN(status stage).
+ */
 void batch_control_write(usb_transfer_batch_t *instance)
 {
@@ -203,4 +256,11 @@
 }
 /*----------------------------------------------------------------------------*/
+/** Prepares control read transfer.
+ *
+ * @param[in] instance Batch structure to use.
+ *
+ * Uses generic control transfer using direction IN(data stage) and
+ * OUT(status stage).
+ */
 void batch_control_read(usb_transfer_batch_t *instance)
 {
@@ -211,4 +271,10 @@
 }
 /*----------------------------------------------------------------------------*/
+/** Prepare interrupt in transfer.
+ *
+ * @param[in] instance Batch structure to use.
+ *
+ * Data transfer.
+ */
 void batch_interrupt_in(usb_transfer_batch_t *instance)
 {
@@ -219,4 +285,10 @@
 }
 /*----------------------------------------------------------------------------*/
+/** Prepare interrupt out transfer.
+ *
+ * @param[in] instance Batch structure to use.
+ *
+ * Data transfer.
+ */
 void batch_interrupt_out(usb_transfer_batch_t *instance)
 {
@@ -229,4 +301,10 @@
 }
 /*----------------------------------------------------------------------------*/
+/** Prepare bulk in transfer.
+ *
+ * @param[in] instance Batch structure to use.
+ *
+ * Data transfer.
+ */
 void batch_bulk_in(usb_transfer_batch_t *instance)
 {
@@ -237,4 +315,10 @@
 }
 /*----------------------------------------------------------------------------*/
+/** Prepare bulk out transfer.
+ *
+ * @param[in] instance Batch structure to use.
+ *
+ * Data transfer.
+ */
 void batch_bulk_out(usb_transfer_batch_t *instance)
 {
@@ -247,12 +331,14 @@
 }
 /*----------------------------------------------------------------------------*/
-ed_t * batch_ed(usb_transfer_batch_t *instance)
-{
-	assert(instance);
-	ohci_transfer_batch_t *data = instance->private_data;
-	assert(data);
-	return data->ed;
-}
-/*----------------------------------------------------------------------------*/
+/** Prepare generic control transfer
+ *
+ * @param[in] instance Batch structure to use.
+ * @param[in] data_dir Direction to use for data stage.
+ * @param[in] status_dir Direction to use for status stage.
+ *
+ * Setup stage with toggle 0 and direction BOTH(SETUP_PID)
+ * Data stage with alternating toggle and direction supplied by parameter.
+ * Status stage with toggle 1 and direction supplied by parameter.
+ */
 void batch_control(usb_transfer_batch_t *instance,
     usb_direction_t data_dir, usb_direction_t status_dir)
@@ -303,4 +389,11 @@
 }
 /*----------------------------------------------------------------------------*/
+/** Prepare generic data transfer
+ *
+ * @param[in] instance Batch structure to use.
+ *
+ * Direction is supplied by the associated ep and toggle is maintained by the
+ * OHCI hw in ED.
+ */
 void batch_data(usb_transfer_batch_t *instance)
 {
@@ -316,6 +409,6 @@
 	char *buffer = instance->data_buffer;
 	while (remain_size > 0) {
-		size_t transfer_size = remain_size > OHCI_TD_MAX_TRANSFER ?
-		    OHCI_TD_MAX_TRANSFER : remain_size;
+		const size_t transfer_size = remain_size > OHCI_TD_MAX_TRANSFER
+		    ? OHCI_TD_MAX_TRANSFER : remain_size;
 
 		td_init(data->tds[td_current], instance->ep->direction,
Index: uspace/drv/ohci/batch.h
===================================================================
--- uspace/drv/ohci/batch.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/ohci/batch.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -26,12 +26,12 @@
  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  */
-/** @addtogroup drvusbuhcihc
+/** @addtogroup drvusbohci
  * @{
  */
 /** @file
- * @brief UHCI driver USB transaction structure
+ * @brief OHCI driver USB transaction structure
  */
-#ifndef DRV_UHCI_BATCH_H
-#define DRV_UHCI_BATCH_H
+#ifndef DRV_OHCI_BATCH_H
+#define DRV_OHCI_BATCH_H
 
 #include <usbhc_iface.h>
@@ -41,9 +41,7 @@
 #include <usb/host/batch.h>
 
-#include "hw_struct/endpoint_descriptor.h"
-
 usb_transfer_batch_t * batch_get(
     ddf_fun_t *fun, endpoint_t *ep, char *buffer, size_t size,
-    char *setup_buffer, size_t setup_size,
+    const char *setup_buffer, size_t setup_size,
     usbhc_iface_transfer_in_callback_t func_in,
     usbhc_iface_transfer_out_callback_t func_out,
@@ -65,6 +63,4 @@
 
 void batch_bulk_out(usb_transfer_batch_t *instance);
-
-ed_t * batch_ed(usb_transfer_batch_t *instance);
 #endif
 /**
Index: uspace/drv/ohci/endpoint_list.c
===================================================================
--- uspace/drv/ohci/endpoint_list.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/ohci/endpoint_list.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -34,4 +34,5 @@
 #include <errno.h>
 #include <usb/debug.h>
+#include <arch/barrier.h>
 
 #include "endpoint_list.h"
@@ -43,5 +44,5 @@
  * @return Error code
  *
- * Allocates memory for internal qh_t structure.
+ * Allocates memory for internal ed_t structure.
  */
 int endpoint_list_init(endpoint_list_t *instance, const char *name)
@@ -68,7 +69,6 @@
  * @param[in] instance List to lead.
  * @param[in] next List to append.
- * @return Error code
  *
- * Does not check whether this replaces an existing list .
+ * Does not check whether this replaces an existing list.
  */
 void endpoint_list_set_next(endpoint_list_t *instance, endpoint_list_t *next)
@@ -79,9 +79,8 @@
 }
 /*----------------------------------------------------------------------------*/
-/** Submit transfer endpoint to the list and queue.
+/** Add endpoint to the list and queue.
  *
  * @param[in] instance List to use.
- * @param[in] endpoint Transfer endpoint to submit.
- * @return Error code
+ * @param[in] endpoint Endpoint to add.
  *
  * The endpoint is added to the end of the list and queue.
@@ -99,19 +98,24 @@
 	/* Add to the hardware queue. */
 	if (list_empty(&instance->endpoint_list)) {
-		/* There is nothing scheduled */
+		/* There are no active EDs */
 		last_ed = instance->list_head;
 	} else {
-		/* There is something scheduled */
+		/* There are active EDs, get the last one */
 		hcd_endpoint_t *last = list_get_instance(
 		    instance->endpoint_list.prev, hcd_endpoint_t, link);
+		assert(last);
 		last_ed = last->ed;
 	}
-	/* keep link */
+	/* Keep link */
 	hcd_ep->ed->next = last_ed->next;
+	/* Make sure ED is written to the memory */
+	write_barrier();
+
+	/* Add ed to the hw queue */
 	ed_append_ed(last_ed, hcd_ep->ed);
+	/* Make sure ED is updated */
+	write_barrier();
 
-	asm volatile ("": : :"memory");
-
-	/* Add to the driver list */
+	/* Add to the sw list */
 	list_append(&hcd_ep->link, &instance->endpoint_list);
 
@@ -129,59 +133,8 @@
 }
 /*----------------------------------------------------------------------------*/
-#if 0
-/** Create list for finished endpoints.
+/** Remove endpoint from the list and queue.
  *
  * @param[in] instance List to use.
- * @param[in] done list to fill
- */
-void endpoint_list_remove_finished(endpoint_list_t *instance, link_t *done)
-{
-	assert(instance);
-	assert(done);
-
-	fibril_mutex_lock(&instance->guard);
-	usb_log_debug2("Checking list %s for completed endpointes(%d).\n",
-	    instance->name, list_count(&instance->endpoint_list));
-	link_t *current = instance->endpoint_list.next;
-	while (current != &instance->endpoint_list) {
-		link_t *next = current->next;
-		hcd_endpoint_t *endpoint =
-		    list_get_instance(current, hcd_endpoint_t, link);
-
-		if (endpoint_is_complete(endpoint)) {
-			/* Save for post-processing */
-			endpoint_list_remove_endpoint(instance, endpoint);
-			list_append(current, done);
-		}
-		current = next;
-	}
-	fibril_mutex_unlock(&instance->guard);
-}
-/*----------------------------------------------------------------------------*/
-/** Walk the list and abort all endpointes.
- *
- * @param[in] instance List to use.
- */
-void endpoint_list_abort_all(endpoint_list_t *instance)
-{
-	fibril_mutex_lock(&instance->guard);
-	while (!list_empty(&instance->endpoint_list)) {
-		link_t *current = instance->endpoint_list.next;
-		hcd_endpoint_t *endpoint =
-		    list_get_instance(current, hcd_endpoint_t, link);
-		endpoint_list_remove_endpoint(instance, endpoint);
-		hcd_endpoint_finish_error(endpoint, EIO);
-	}
-	fibril_mutex_unlock(&instance->guard);
-}
-#endif
-/*----------------------------------------------------------------------------*/
-/** Remove a transfer endpoint from the list and queue.
- *
- * @param[in] instance List to use.
- * @param[in] endpoint Transfer endpoint to remove.
- * @return Error code
- *
- * Does not lock the transfer list, caller is responsible for that.
+ * @param[in] endpoint Endpoint to remove.
  */
 void endpoint_list_remove_ep(endpoint_list_t *instance, hcd_endpoint_t *hcd_ep)
@@ -212,6 +165,7 @@
 	assert((prev_ed->next & ED_NEXT_PTR_MASK) == addr_to_phys(hcd_ep->ed));
 	prev_ed->next = hcd_ep->ed->next;
+	/* Make sure ED is updated */
+	write_barrier();
 
-	asm volatile ("": : :"memory");
 	usb_log_debug("HCD EP(%p) removed (%s) from %s, next %x.\n",
 	    hcd_ep, qpos, instance->name, hcd_ep->ed->next);
Index: uspace/drv/ohci/endpoint_list.h
===================================================================
--- uspace/drv/ohci/endpoint_list.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/ohci/endpoint_list.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -41,10 +41,15 @@
 #include "utils/malloc32.h"
 
-typedef struct endpoint_list
-{
+/** Structure maintains both OHCI queue and software list of active endpoints.*/
+typedef struct endpoint_list {
+	/** Guard against add/remove races */
 	fibril_mutex_t guard;
+	/** OHCI hw structure at the beginning of the queue */
 	ed_t *list_head;
+	/** Physical address of the first(dummy) ED */
 	uint32_t list_head_pa;
+	/** Assigned name, provides nicer debug output */
 	const char *name;
+	/** Sw list of all active EDs */
 	link_t endpoint_list;
 } endpoint_list_t;
@@ -54,5 +59,5 @@
  * @param[in] instance Memory place to use.
  *
- * Frees memory for internal qh_t structure.
+ * Frees memory of the internal ed_t structure.
  */
 static inline void endpoint_list_fini(endpoint_list_t *instance)
@@ -63,15 +68,7 @@
 
 int endpoint_list_init(endpoint_list_t *instance, const char *name);
-
 void endpoint_list_set_next(endpoint_list_t *instance, endpoint_list_t *next);
-
 void endpoint_list_add_ep(endpoint_list_t *instance, hcd_endpoint_t *hcd_ep);
-
 void endpoint_list_remove_ep(endpoint_list_t *instance, hcd_endpoint_t *hcd_ep);
-#if 0
-void endpoint_list_remove_finished(endpoint_list_t *instance, link_t *done);
-
-void endpoint_list_abort_all(endpoint_list_t *instance);
-#endif
 #endif
 /**
Index: uspace/drv/ohci/hc.c
===================================================================
--- uspace/drv/ohci/hc.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/ohci/hc.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -51,4 +51,10 @@
 static int hc_init_memory(hc_t *instance);
 /*----------------------------------------------------------------------------*/
+/** Announce OHCI root hub to the DDF
+ *
+ * @param[in] instance OHCI driver intance
+ * @param[in] hub_fun DDF fuction representing OHCI root hub
+ * @return Error code
+ */
 int hc_register_hub(hc_t *instance, ddf_fun_t *hub_fun)
 {
@@ -56,10 +62,9 @@
 	assert(hub_fun);
 
-	int ret;
-
-	usb_address_t hub_address =
+	const usb_address_t hub_address =
 	    device_keeper_get_free_address(&instance->manager, USB_SPEED_FULL);
 	if (hub_address <= 0) {
-		usb_log_error("Failed to get OHCI root hub address.\n");
+		usb_log_error("Failed(%d) to get OHCI root hub address.\n",
+		    hub_address);
 		return hub_address;
 	}
@@ -68,30 +73,40 @@
 	    &instance->manager, hub_address, hub_fun->handle);
 
-	ret = hc_add_endpoint(instance, hub_address, 0, USB_SPEED_FULL,
+#define CHECK_RET_RELEASE(ret, message...) \
+if (ret != EOK) { \
+	usb_log_error(message); \
+	hc_remove_endpoint(instance, hub_address, 0, USB_DIRECTION_BOTH); \
+	usb_device_keeper_release(&instance->manager, hub_address); \
+	return ret; \
+} else (void)0
+
+	int ret = hc_add_endpoint(instance, hub_address, 0, USB_SPEED_FULL,
 	    USB_TRANSFER_CONTROL, USB_DIRECTION_BOTH, 64, 0, 0);
-	if (ret != EOK) {
-		usb_log_error("Failed to add OHCI rh endpoint 0.\n");
-		usb_device_keeper_release(&instance->manager, hub_address);
-		return ret;
-	}
+	CHECK_RET_RELEASE(ret, "Failed(%d) to add OHCI rh endpoint 0.\n", ret);
 
 	char *match_str = NULL;
 	/* DDF needs heap allocated string */
 	ret = asprintf(&match_str, "usb&class=hub");
-	if (ret < 0) {
-		usb_log_error(
-		    "Failed(%d) to create root hub match-id string.\n", ret);
-		usb_device_keeper_release(&instance->manager, hub_address);
-		return ret;
-	}
+	ret = ret > 0 ? 0 : ret;
+	CHECK_RET_RELEASE(ret, "Failed(%d) to create match-id string.\n", ret);
 
 	ret = ddf_fun_add_match_id(hub_fun, match_str, 100);
-	if (ret != EOK) {
-		usb_log_error("Failed add root hub match-id.\n");
-	}
+	CHECK_RET_RELEASE(ret, "Failed(%d) add root hub match-id.\n", ret);
+
 	ret = ddf_fun_bind(hub_fun);
-	return ret;
-}
-/*----------------------------------------------------------------------------*/
+	CHECK_RET_RELEASE(ret, "Failed(%d) to bind root hub function.\n", ret);
+
+	return EOK;
+#undef CHECK_RET_RELEASE
+}
+/*----------------------------------------------------------------------------*/
+/** Initialize OHCI hc driver structure
+ *
+ * @param[in] instance Memory place for the structure.
+ * @param[in] regs Address of the memory mapped I/O registers.
+ * @param[in] reg_size Size of the memory mapped area.
+ * @param[in] interrupts True if w interrupts should be used
+ * @return Error code
+ */
 int hc_init(hc_t *instance, uintptr_t regs, size_t reg_size, bool interrupts)
 {
@@ -121,8 +136,6 @@
 #undef CHECK_RET_RETURN
 
-
-//	hc_init_hw(instance);
+	fibril_mutex_initialize(&instance->guard);
 	hc_gain_control(instance);
-	fibril_mutex_initialize(&instance->guard);
 
 	rh_init(&instance->rh, instance->registers);
@@ -137,4 +150,17 @@
 }
 /*----------------------------------------------------------------------------*/
+/** Create end register endpoint structures
+ *
+ * @param[in] instance OHCI driver structure.
+ * @param[in] address USB address of the device.
+ * @param[in] endpoint USB endpoint number.
+ * @param[in] speed Communication speeed of the device.
+ * @param[in] type Endpoint's transfer type.
+ * @param[in] direction Endpoint's direction.
+ * @param[in] mps Maximum packet size the endpoint accepts.
+ * @param[in] size Maximum allowed buffer size.
+ * @param[in] interval Time between transfers(interrupt transfers only).
+ * @return Error code
+ */
 int hc_add_endpoint(
     hc_t *instance, usb_address_t address, usb_endpoint_t endpoint,
@@ -194,4 +220,12 @@
 }
 /*----------------------------------------------------------------------------*/
+/** Dequeue and delete endpoint structures
+ *
+ * @param[in] instance OHCI hc driver structure.
+ * @param[in] address USB address of the device.
+ * @param[in] endpoint USB endpoint number.
+ * @param[in] direction Direction of the endpoint.
+ * @return Error code
+ */
 int hc_remove_endpoint(hc_t *instance, usb_address_t address,
     usb_endpoint_t endpoint, usb_direction_t direction)
@@ -244,4 +278,13 @@
 }
 /*----------------------------------------------------------------------------*/
+/** Get access to endpoint structures
+ *
+ * @param[in] instance OHCI hc driver structure.
+ * @param[in] address USB address of the device.
+ * @param[in] endpoint USB endpoint number.
+ * @param[in] direction Direction of the endpoint.
+ * @param[out] bw Reserved bandwidth.
+ * @return Error code
+ */
 endpoint_t * hc_get_endpoint(hc_t *instance, usb_address_t address,
     usb_endpoint_t endpoint, usb_direction_t direction, size_t *bw)
@@ -255,4 +298,10 @@
 }
 /*----------------------------------------------------------------------------*/
+/** Add USB transfer to the schedule.
+ *
+ * @param[in] instance OHCI hc driver structure.
+ * @param[in] batch Batch representing the transfer.
+ * @return Error code.
+ */
 int hc_schedule(hc_t *instance, usb_transfer_batch_t *batch)
 {
@@ -261,5 +310,5 @@
 	assert(batch->ep);
 
-	/* check for root hub communication */
+	/* Check for root hub communication */
 	if (batch->ep->address == instance->rh.address) {
 		return rh_request(&instance->rh, batch);
@@ -269,5 +318,8 @@
 	list_append(&batch->link, &instance->pending_batches);
 	batch_commit(batch);
-	switch (batch->ep->transfer_type) {
+
+	/* Control and bulk schedules need a kick to start working */
+	switch (batch->ep->transfer_type)
+	{
 	case USB_TRANSFER_CONTROL:
 		instance->registers->command_status |= CS_CLF;
@@ -279,9 +331,13 @@
 		break;
 	}
-
 	fibril_mutex_unlock(&instance->guard);
 	return EOK;
 }
 /*----------------------------------------------------------------------------*/
+/** Interrupt handling routine
+ *
+ * @param[in] instance OHCI hc driver structure.
+ * @param[in] status Value of the status register at the time of interrupt.
+ */
 void hc_interrupt(hc_t *instance, uint32_t status)
 {
@@ -292,5 +348,4 @@
 	if (status & I_RHSC)
 		rh_interrupt(&instance->rh);
-
 
 	if (status & I_WDH) {
@@ -316,6 +371,16 @@
 		fibril_mutex_unlock(&instance->guard);
 	}
-}
-/*----------------------------------------------------------------------------*/
+
+	if (status & I_UE) {
+		hc_start_hw(instance);
+	}
+
+}
+/*----------------------------------------------------------------------------*/
+/** Check status register regularly
+ *
+ * @param[in] instance OHCI hc driver structure.
+ * @return Error code
+ */
 int interrupt_emulator(hc_t *instance)
 {
@@ -326,9 +391,13 @@
 		instance->registers->interrupt_status = status;
 		hc_interrupt(instance, status);
-		async_usleep(50000);
+		async_usleep(10000);
 	}
 	return EOK;
 }
 /*----------------------------------------------------------------------------*/
+/** Turn off any (BIOS)driver that might be in control of the device.
+ *
+ * @param[in] instance OHCI hc driver structure.
+ */
 void hc_gain_control(hc_t *instance)
 {
@@ -380,4 +449,8 @@
 }
 /*----------------------------------------------------------------------------*/
+/** OHCI hw initialization routine.
+ *
+ * @param[in] instance OHCI hc driver structure.
+ */
 void hc_start_hw(hc_t *instance)
 {
@@ -447,8 +520,12 @@
 }
 /*----------------------------------------------------------------------------*/
+/** Initialize schedule queues
+ *
+ * @param[in] instance OHCI hc driver structure
+ * @return Error code
+ */
 int hc_init_transfer_lists(hc_t *instance)
 {
 	assert(instance);
-
 #define SETUP_ENDPOINT_LIST(type) \
 do { \
@@ -458,8 +535,9 @@
 		usb_log_error("Failed(%d) to setup %s endpoint list.\n", \
 		    ret, name); \
-		endpoint_list_fini(&instance->lists[USB_TRANSFER_ISOCHRONOUS]); \
+		endpoint_list_fini(&instance->lists[USB_TRANSFER_ISOCHRONOUS]);\
 		endpoint_list_fini(&instance->lists[USB_TRANSFER_INTERRUPT]); \
 		endpoint_list_fini(&instance->lists[USB_TRANSFER_CONTROL]); \
 		endpoint_list_fini(&instance->lists[USB_TRANSFER_BULK]); \
+		return ret; \
 	} \
 } while (0)
@@ -476,4 +554,9 @@
 }
 /*----------------------------------------------------------------------------*/
+/** Initialize memory structures used by the OHCI hcd.
+ *
+ * @param[in] instance OHCI hc driver structure.
+ * @return Error code.
+ */
 int hc_init_memory(hc_t *instance)
 {
@@ -502,4 +585,5 @@
 	/* Init interrupt code */
 	instance->interrupt_code.cmds = instance->interrupt_commands;
+	instance->interrupt_code.cmdcount = OHCI_NEEDED_IRQ_COMMANDS;
 	{
 		/* Read status register */
@@ -521,5 +605,5 @@
 		instance->interrupt_commands[2].srcarg = 2;
 
-		/* Write clean status register */
+		/* Write-clean status register */
 		instance->interrupt_commands[3].cmd = CMD_MEM_WRITE_A_32;
 		instance->interrupt_commands[3].srcarg = 1;
@@ -529,6 +613,4 @@
 		/* Accept interrupt */
 		instance->interrupt_commands[4].cmd = CMD_ACCEPT;
-
-		instance->interrupt_code.cmdcount = OHCI_NEEDED_IRQ_COMMANDS;
 	}
 
Index: uspace/drv/ohci/hc.h
===================================================================
--- uspace/drv/ohci/hc.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/ohci/hc.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -53,17 +53,25 @@
 #define OHCI_NEEDED_IRQ_COMMANDS 5
 
+/** Main OHCI drier structure */
 typedef struct hc {
+	/** USB bus driver, devices and addresses */
+	usb_device_keeper_t manager;
+	/** USB bus driver, endpoints */
+	usb_endpoint_manager_t ep_manager;
+
+	/** Memory mapped I/O registers area */
 	ohci_regs_t *registers;
+	/** Host controller communication area structure */
 	hcca_t *hcca;
 
-	usb_address_t rh_address;
-	rh_t rh;
-
+	/** Transfer schedules */
 	endpoint_list_t lists[4];
+	/** List of active transfers */
 	link_t pending_batches;
 
-	usb_device_keeper_t manager;
-	usb_endpoint_manager_t ep_manager;
+	/** Fibril for periodic checks if interrupts can't be used */
 	fid_t interrupt_emulator;
+
+	/** Guards schedule and endpoint manipulation */
 	fibril_mutex_t guard;
 
@@ -73,10 +81,11 @@
 	/** Commands that form interrupt code */
 	irq_cmd_t interrupt_commands[OHCI_NEEDED_IRQ_COMMANDS];
+
+	/** USB hub emulation structure */
+	rh_t rh;
 } hc_t;
 
 int hc_register_hub(hc_t *instance, ddf_fun_t *hub_fun);
-
 int hc_init(hc_t *instance, uintptr_t regs, size_t reg_size, bool interrupts);
-
 void hc_start_hw(hc_t *instance);
 
@@ -85,18 +94,16 @@
  * @param[in] instance Host controller structure to use.
  */
-static inline void hc_fini(hc_t *instance) { /* TODO: implement*/ };
+static inline void hc_fini(hc_t *instance)
+	{ /* TODO: implement*/ };
 
 int hc_add_endpoint(hc_t *instance, usb_address_t address, usb_endpoint_t ep,
     usb_speed_t speed, usb_transfer_type_t type, usb_direction_t direction,
     size_t max_packet_size, size_t size, unsigned interval);
-
 int hc_remove_endpoint(hc_t *instance, usb_address_t address,
     usb_endpoint_t endpoint, usb_direction_t direction);
-
 endpoint_t * hc_get_endpoint(hc_t *instance, usb_address_t address,
     usb_endpoint_t endpoint, usb_direction_t direction, size_t *bw);
 
 int hc_schedule(hc_t *instance, usb_transfer_batch_t *batch);
-
 void hc_interrupt(hc_t *instance, uint32_t status);
 
@@ -107,5 +114,5 @@
  */
 static inline hc_t * fun_to_hc(ddf_fun_t *fun)
-	{ return (hc_t*)fun->driver_data; }
+	{ return fun->driver_data; }
 #endif
 /**
Index: uspace/drv/ohci/hcd_endpoint.c
===================================================================
--- uspace/drv/ohci/hcd_endpoint.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/ohci/hcd_endpoint.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -35,4 +35,9 @@
 #include "hcd_endpoint.h"
 
+/** Callback to set toggle on ED.
+ *
+ * @param[in] hcd_ep hcd endpoint structure
+ * @param[in] toggle new value of toggle bit
+ */
 static void hcd_ep_toggle_set(void *hcd_ep, int toggle)
 {
@@ -42,4 +47,10 @@
 	ed_toggle_set(instance->ed, toggle);
 }
+/*----------------------------------------------------------------------------*/
+/** Callback to get value of toggle bit.
+ *
+ * @param[in] hcd_ep hcd endpoint structure
+ * @return Current value of toggle bit.
+ */
 static int hcd_ep_toggle_get(void *hcd_ep)
 {
@@ -49,6 +60,10 @@
 	return ed_toggle_get(instance->ed);
 }
-
-
+/*----------------------------------------------------------------------------*/
+/** Creates new hcd endpoint representation.
+ *
+ * @param[in] ep USBD endpoint structure
+ * @return pointer to a new hcd endpoint structure, NULL on failure.
+ */
 hcd_endpoint_t * hcd_endpoint_assign(endpoint_t *ep)
 {
@@ -78,10 +93,8 @@
 }
 /*----------------------------------------------------------------------------*/
-hcd_endpoint_t * hcd_endpoint_get(endpoint_t *ep)
-{
-	assert(ep);
-	return ep->hc_data.data;
-}
-/*----------------------------------------------------------------------------*/
+/** Disposes assigned hcd endpoint structure
+ *
+ * @param[in] ep USBD endpoint structure
+ */
 void hcd_endpoint_clear(endpoint_t *ep)
 {
Index: uspace/drv/ohci/hcd_endpoint.h
===================================================================
--- uspace/drv/ohci/hcd_endpoint.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ uspace/drv/ohci/hcd_endpoint.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -37,5 +37,4 @@
 #include <assert.h>
 #include <adt/list.h>
-
 #include <usb/host/endpoint.h>
 
@@ -43,15 +42,27 @@
 #include "hw_struct/transfer_descriptor.h"
 
+/** Connector structure linking ED to to prepared TD. */
 typedef struct hcd_endpoint {
+	/** OHCI endpoint descriptor */
 	ed_t *ed;
+	/** Currently enqueued transfer descriptor */
 	td_t *td;
+	/** Linked list used by driver software */
 	link_t link;
 } hcd_endpoint_t;
 
 hcd_endpoint_t * hcd_endpoint_assign(endpoint_t *ep);
+void hcd_endpoint_clear(endpoint_t *ep);
 
-hcd_endpoint_t * hcd_endpoint_get(endpoint_t *ep);
+/** Get and convert assigned hcd_endpoint_t structure
+ * @param[in] ep USBD endpoint structure.
+ * @return Pointer to assigned hcd endpoint structure
+ */
+static inline hcd_endpoint_t * hcd_endpoint_get(endpoint_t *ep)
+{
+	assert(ep);
+	return ep->hc_data.data;
+}
 
-void hcd_endpoint_clear(endpoint_t *ep);
 #endif
 /**
